#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <cstdio>
#include <set>

#define REP(i,n) for (int i=0;i<n;++i)

using namespace std;

int main() {
    while (1) {
	int n;
	cin>>n;
	if (n==0) {cout<<"goodbye"<<endl; return 0;}	
	map <string,double> account;
	set <string> exist;
	string a; double b;
	REP(i,n) {
	    cin>>a>>b;
	    account[a]=b;
	    exist.insert(a);
	}
	while (1) {
	    string type;
	    cin>>type;
	    if (type=="end") {
		cout<<"end"<<endl<<endl;
		break;
	    }
		if (type=="deposit") {
		    string ac; double sum;
		    cin>>ac>>sum;
		    if (exist.count(ac)) {
			account[ac]+=sum;
			cout<<"deposit "; printf("%.2f",sum); cout<<": ok"<<endl;
		    } else { cout<<"deposit "; printf("%.2f",sum); cout<<": no such account"<<endl;}
		}
	    
	    if (type=="withdraw") {
		string ac; double sum;
		cin>>ac>>sum;
		if (exist.count(ac)) {
		    if (account[ac]>=sum) {
			account[ac]-=sum;
			{ cout<<"withdraw "; printf("%.2f",sum); cout<<": ok"<<endl;}
		    } else {
			{ cout<<"withdraw "; printf("%.2f",sum); cout<<": insufficient funds"<<endl;}
		    }
		} else { cout<<"withdraw "; printf("%.2f",sum); cout<<": no such account"<<endl;}
	    }
	    if (type=="create") {
		string ac;
		cin>>ac;
		if (exist.count(ac)) {
		    cout<<"create: already exists"<<endl;
		} else {
		    exist.insert(ac);
		    account[ac]=0.0;
		    cout<<"create: ok"<<endl;
		}
	    }
	    if (type=="transfer") {
		string z,na; double sum;
		cin>>z>>na>>sum;
		if (exist.count(z) && exist.count(na)) {
		    if (z==na) {{ cout<<"transfer "; printf("%.2f",sum); cout<<": same account"<<endl;}
		    } else if (account[z]<sum) {{ cout<<"transfer "; printf("%.2f",sum); cout<<": insufficient funds"<<endl;}
		    } else {
			account[z]-=sum;
			account[na]+=sum;
			if (z[z.size()-1]==na[na.size()-1]) { cout<<"transfer "; printf("%.2f",sum); cout<<": ok"<<endl;}
			else { cout<<"transfer "; printf("%.2f",sum); cout<<": interbank"<<endl;}
		    }
		} else { cout<<"transfer "; printf("%.2f",sum); cout<<": no such account"<<endl;}

	    }

	}
    }
}
