#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iostream>

struct ltstr
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) < 0;
  }
};

using namespace std;

char L[2][2048][11];
int N[2];
const char * ntow[4096];
int W[2][2048];

int M[2002][2048];
int A[4096];

int main()
{
    for (;;) {
	for (int i = 0; i < 2; ++i) {
	    for (N[i] = 0; ; ++N[i]) {
		if (scanf("%s", L[i][N[i]]) != 1)
		    return 0;
		if (!strcmp(L[i][N[i]], "."))
		    break;
	    }
	}
	set<const char *, ltstr> words;
	for (int i = 0; i < 2; ++i)
	    for (int j = 0; j < N[i]; ++j) {
		words.insert(L[i][j]);
	    }
	map<const char *, int, ltstr> wton;
	int n = 1;
	for (set<const char *, ltstr>::iterator w = words.begin();
		w != words.end(); ++w) {
	    wton[*w] = n;
	    ntow[n] = *w;
	    ++n;
	}
	for (int i = 0; i < 2; ++i)
	    for (int j = 0; j < N[i]; ++j)
		W[i][j] = wton[L[i][j]];
	for (int i = 0; i < N[0]; ++i)
	    printf("%3d", W[0][i]);
	puts("");
	for (int i = 0; i < N[1]; ++i)
	    printf("%3d", W[1][i]);
	puts("");
	puts("");

	for (int i = 0; i <= max(N[0], N[1]); ++i)
	    M[i][0] = 0;
	for (int i = 0; i <= max(N[0], N[1]); ++i)
	    M[0][i] = 0;

	for (int i = 1; i <= N[0]; ++i)
	    for (int j = 1; j <= N[1]; ++j) {
		M[i][j] = max(M[i-1][j], M[i][j-1]);
		M[i][j] = max(M[i][j], M[i-1][j-1] + (W[0][i-1] == W[1][j-1]));
	    }
	for (int i = 0; i <= N[0]; ++i) {
	    for (int j = 0; j <= N[1]; ++j)
		printf("%3d", M[i][j]);
	    printf("\n");
	}
	queue<pair<int, int> > q;
	int i = N[0];
	int j = N[1];
	q.push(make_pair(i,j));
	while (i + j) {
	    int c = M[i][j];
	    while (i && M[i-1][j] == c)
		--i;
	    while (j && M[i][j-1] == c)
		--j;
	    q.push(make_pair(i,j));
	    --i; --j;
	}
	while (q.size()) {
	    pair<int,int> p = q.front();
	    q.pop();
	    cerr << "a" << endl;
	    while (i < p.first || j < p.second) {
		cerr << i << " " << j << endl;
		if (i < p.first && (j == p.second ||
			    (W[0][i] < W[1][j]))) {
		    printf("%s ", ntow[W[0][++i]]);
		} else
		    printf("%s ", ntow[W[1][++j]]);
	    }
	}
	printf(".\n");
    }
    return 0;
}
